OUTPUT_FORMAT("coff-h8300")
OUTPUT_ARCH(h8300h)
ENTRY("_start")
MEMORY
{
	vectors    : o = 0x000000, l = 0x000100
	rom(rx)    : o = 0x008000, l = 0x018000
	ram(rwx)   : o = 0xfff400, l = 0x000920
	stack(rw)  : o = 0xffff1c, l = 0x000004
}
SECTIONS 				
{
.vectors : {
	*(.vectors)
	} > vectors 					
.text : {
	*(.text)		
	*(.strings)
	*(.rodata)
   	 _etext = . ; 
	} > rom
.tors : {
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	___dtors_end = . ;
	}  > rom
.data : AT ( ADDR(.tors) + SIZEOF(.tors) ){
	___data = . ;
	*(.data)
	*(.tiny)
	 _edata = .;
	} > ram
.bss : {
	 _bss_start = . ;
	*(.bss)
	*(COMMON)
	 _end = . ;  
	}  >ram
.stack : {
	 _stack = . ; 
	*(.stack)
	}  > stack
}
