#include "config.h"
#include "support.h"

unsigned short makesum(unsigned char *start, unsigned long bytes)
{
  unsigned short sum = 0;

  for(; bytes > 0; bytes--)
    sum += *start++;
  return sum;
}

int _sleepa(unsigned short step)
{
  ITU4.TCR.BYTE = 0x03; 
  ITU4.TCNT = 0;
  ITU.TSTR.BIT.STR4 = 1;
  ITU4.GRA = step; 
  
  ITU4.TSR.BIT.IMFA;
  ITU4.TSR.BIT.IMFA = 0;

#ifndef SIM_DEBUG
  while (!ITU4.TSR.BIT.IMFA);
#endif  

  ITU.TSTR.BIT.STR4 = 0;
  return 0;
}

int sleepinms(unsigned short ms)
{
  unsigned short cnt;

  ITU4.TCR.BYTE = 0x23; //be cleared by GRA
  ITU4.TCNT = 0;
  ITU4.GRA = CLOCK_IN_Hz / 1000 / 8; //1ms
  ITU.TSTR.BIT.STR4 = 1;
  
  ITU4.TSR.BIT.IMFA;
#ifndef SIM_DEBUG
  for(cnt = 0; cnt < ms; cnt++)
    {
      ITU4.TSR.BIT.IMFA = 0;
      while (!ITU4.TSR.BIT.IMFA);
    }
#endif

  ITU.TSTR.BIT.STR4 = 0;
  return 0;
}
