#include <string.h>
#include "sci.h"
#include "sio.h"
#include "config.h"
#include "io.h"

#ifndef NOUSE_OPEN
int is_sci0_opened = 0;

int open (const char *name, int flags)
{
  
  if(!strcmp(name, DEV_SCI0))
    {
/*
      if(is_SCI0_opened)
	{
	  //	  errno = EMFILE;
	  return -1;
	}
*/
      InitSCI0(0, 0, 0, DEF_BAUDRATE);

      is_sci0_opened = 1;
      return FD_SCI0;
    }
  //  errno = ENXIO;
  return -1;
}

int close (int fd)
{
  if(fd == FD_SCI0)
    {
      if(!is_SCI0_opened)
	{
	  //	  errno = EBADF;
	  return -1;
	}

      CloseSCI0();
      is_SCI0_opened = 0;
      return 0;
    }
  //  errno = EBADF;
  return -1;
}
#endif

int write (int fd, char *buf, int count)
{
  int n;

  if(fd == FD_SCI0)
    {
#ifndef NOUSE_OPEN
      if(!is_SCI0_opened)
	{
	  //	  errno = EBADF;
	  return -1;
	}
#endif
#ifdef SIM_DEBUG
      n = fwrite(buf, 1, count, stdout);
#else
      n = WriteSCI0(count, buf);
#endif
      return n;
    }
  //  errno = EBADF;
  return -1;
}

int read (int fd, char *buf, int count)
{
  int n;

  if(fd == FD_SCI0)
    {
#ifndef NOUSE_OPEN
      if(!is_SCI0_opened)
	{
	  //	  errno = EBADF;
	  return -1;
	}
#endif
#ifdef SIM_DEBUG
      n = fread(buf, 1, count, stdin);
#else
      n = ReadSCI0(count, buf);
#endif
      return n;
    }
  //  errno = EBADF;
  return -1;
}

#ifndef NOUSE_OPEN
int ioctl(int fd, int request)
{
  if(fd == FD_SCI0)
    {
      if(request == REQ_FLUSHRDRF)
	{
	  return FlushRDRFSCI0();
	}
    }
  return -1;
}
#endif
