#include "config.h"
#include "support.h"

unsigned short makesum(unsigned char *start, unsigned int bytes)
{
  unsigned short sum = 0;

  for(; bytes > 0; bytes--)
    sum += *start++;
  return sum;
}

int _sleepa(unsigned short step)
{
  ITU2.TCR.BYTE = 0x03; 
  ITU2.TCNT = 0;
  ITU.TSTR.BIT.STR2 = 1;
  ITU2.GRA = step; 
  
  ITU2.TSR.BIT.IMFA;
  ITU2.TSR.BIT.IMFA = 0;
  while (!ITU2.TSR.BIT.IMFA);
  
  ITU.TSTR.BIT.STR2 = 0;
  return 0;
}

int sleepinms(unsigned short ms)
{
  unsigned short cnt;

  ITU2.TCR.BYTE = 0x23; //be cleared by GRA
  ITU2.TCNT = 0;
  ITU2.GRA = CLOCK_IN_Hz / 1000 / 8; //1ms
  ITU.TSTR.BIT.STR2 = 1;
  
  ITU2.TSR.BIT.IMFA;
  for(cnt = 0; cnt < ms; cnt++)
    {
      ITU2.TSR.BIT.IMFA = 0;
      while (!ITU2.TSR.BIT.IMFA);
    }

  ITU.TSTR.BIT.STR2 = 0;
  return 0;
}
